﻿<div class="jumbotron">
    <h1>My Videogame Collection</h1>
    <p class="lead">Edit and add videogames and accessories to your personal collection</p>
</div>
<div class="row">
    <div class="col-md-4">
        <select id="platforms"></select>
        <ul id="accessories"></ul>
    </div>
    <div class="col-md-4">
        <form name="formEditAccessory" id="formEditAccessory">
            <label>Name: <input type="text" id="Name" /></label><br />
            <label>Type: <input type="text" id="Type" /></label><br />
            <label>Condition: <input type="text" id="Condition" /></label><br />
            <input type="submit" id="editAccessory" value="Update Accessory" /><br />
            <input type="hidden" id="hiddenAccessoryId" />
        </form>
    </div>
    <div class="col-md-4">
        <form name="formAddAccessory" id="formAddAccessory">
            <label>Name: <input type="text" id="NameForAdd" /></label><br />
            <label>Type: <input type="text" id="TypeForAdd" /></label><br />
            <label>Condition: <input type="text" id="ConditionForAdd" /></label><br />
            <label>Platform: <select id="platformsForAdd"></select></label><br />
            <input type="submit" id="addAccessory" value="Add new Accessory" /><br />
        </form>
    </div>
</div>
<script>

    // Accessory accessory Accessories accessories
    (function () {
        var accessoriesOnPlat;
        var plats; //platforms
        var selectedPlatId;
        var accessoriesListToUpdate = $("#accessories");
        var platSelectToUpdate = $("#platforms");
        var platSelectForAdd = $("#platformsForAdd");
        var selectedAccessory;
        getPlatforms(fillPlatformLists);
        //alert("Hello");
        getAccessoriesByPlat(1, fillAccessoriesList);

        //$("#formAddAccessory").off("submit");
        $("#formAddAccessory").on("submit", processAddAccessory);

        function getAccessoriesByPlat(platId, callBackWhenDone) {
            accessoriesOnPlat = "loading";
            var jqxhr = $.getJSON("/api/platform/" + platId + "/accessory", function (data) {
                console.log("success");
                //alert(data);
                accessoriesOnPlat = data;
                callBackWhenDone();
            })
          .done(function () {
              console.log("second success");
          })
          .fail(function () {
              console.log("error");
          })
          .always(function () {
              console.log("complete");
          });
        }

        function getPlatforms(callBackWhenDone) {
            //uses platform array in closure variable
            plats = "loading";

            var jqxhr = $.getJSON("/api/platform/", function (data) {
                console.log("success");
                plats = data;
                callBackWhenDone();
              })
              .done(function () {
                  console.log("second success");
              })
              .fail(function () {
                  console.log("error");
              })
              .always(function () {
                  console.log("complete");
              });
        }

        function fillAccessoriesList() {
            //uses accessoriesOnPlat accessories array in closure variable
            //uses accessoriesListToUpdate list in closure variable
            accessoriesListToUpdate.html("");
            $.each(accessoriesOnPlat, function (a, acc) {
                var myLi = $("<li></li>");
                myLi.attr("id", "acc_" + acc.AccessoryId);
                //myLi.off("click");
                myLi.on("click", selectAccessory);
                myLi.html(acc.Name);
                accessoriesListToUpdate.append(myLi);
            });
        }

        function platformChange() {
            var platId = $(this).find(":selected").attr("id").substring(4);
            //alert("PLATID: " + platId);
            accessoriesListToUpdate = $("#accessories");
            getAccessoriesByPlat(platId, fillAccessoriesList);
        }

        function selectAccessory() {
            var accId = this.id.substring(4);
            alert(accId);
            selectedAccessory = "none";
            $.each(accessoriesOnPlat, function (a, acc) {
                if (acc.AccessoryId == accId) {
                    selectedAccessory = acc;
                }
            });

            if (selectedAccessory != "none") {
                $("#Name").val(selectedAccessory.Name);
                $("#Type").val(selectedAccessory.Type);
                $("#Condition").val(selectedAccessory.Condition);
                $("#hiddenAccessoryId").val(selectedAccessory.AccessoryId);
                $("#formEditAccessory").off("submit");
                $("#formEditAccessory").on("submit", processUpdateAccessory);
            }
        }

        function fillPlatformLists() {
            //uses platform array in closure variable
            //uses platSelectToUpdate select in closure variable
            platSelectToUpdate.html("");
            platSelectForAdd.html("");
            $.each(plats, function (a, acc) {
                var myoption = $("<option></option>");
                myoption.attr("id", "acc_" + acc.PlatformId);
                myoption.html(acc.Name);
                platSelectToUpdate.append(myoption);

                var myoptionAdd = $("<option></option>");
                myoptionAdd.attr("id", "plat_add_" + acc.PlatformId);
                myoptionAdd.html(acc.Name);
                platSelectForAdd.append(myoptionAdd);
            });
            platSelectToUpdate.off("change");
            platSelectToUpdate.on("change", platformChange);
        }



        function processUpdateAccessory() {
            // uses selectedAccessory accessory in closure variable
            var accName = $("#Name").val();
            var accType = $("#Type").val();
            var accCondition = $("#Condition").val();

            selectedAccessory.Name = accName;
            selectedAccessory.Type = accType;
            selectedAccessory.Condition = accCondition;

            $.ajax({
                contentType: 'application/json',
                url: "/api/accessory/" + selectedAccessory.AccessoryId,
                type: 'PUT',
                data: JSON.stringify(selectedAccessory),
                success: function (result) {
                    //alert("success?");
                },
                error: (function (xhr) {
                    console.log("error: " + xhr.status);
                    alert("failure: " + xhr.status);
                })
            });

            return false; // stop form submit
        }

        function processAddAccessory() {
            // uses selectedAccessory accessory in closure variable
            var accName = $("#NameForAdd").val();
            var accType = $("#TypeForAdd").val();
            var accCondition = $("#ConditionForAdd").val();
            var accPlatId = $("#platformsForAdd option:selected").attr("id").substring(9);

            alert(accPlatId);

            var newAccessory = new Object();
            newAccessory.Name = accName;
            newAccessory.Type = accType;
            newAccessory.Condition = accCondition;
            //alert(accPlatId);
            //alert(JSON.stringify(newAccessory));
            if (!isNaN(parseInt(accPlatId))) {
                $.ajax({
                    contentType: 'application/json',
                    url: "/api/platform/" + accPlatId + "/accessory/",
                    type: 'POST',
                    data: JSON.stringify(newAccessory),
                    success: function (result) {
                        alert("success?");
                    },
                    error: (function (xhr) {
                        console.log("error: " + xhr.status);
                        alert("failure: " + xhr.status);
                    })
                });
            }
            else
                alert("Select a Platform");

            return false; // stop form submit
        }

    }());



</script>
